#include "piscine.h"
#include <Imagine/Graphics.h>
#include <iostream>
#include <cstdlib>
#include <cassert>
using namespace Imagine;
using namespace std;

// Q2
const int nbcoul=6;
const Color coul[nbcoul+2] = {RED, GREEN, BLUE, CYAN, YELLOW, MAGENTA,
                              WHITE, BLACK};
const int tailleTexte=16;

// Q3
Piscine::Piscine(int width, int height, int init) {
    w=width; h=height;
    assert(init<h);
    parite=(init+1)%2;
    bulles = new int[w*h];
    for(int y=0; y<init; y++)
        nouvelle_ligne(y);
    for(int y=init; y<h; y++)
        for(int x=0; x<w; x++)
            bulles[y*w+x] = nbcoul;
    vu = new bool[w*h];
    score=0; // Q21
    prochaineCoul=rand()%nbcoul; // Q22
}

// Q3
Piscine::~Piscine() {
    delete [] bulles;
    delete [] vu;
}

// Q4
void Piscine::nouvelle_ligne(int y) {
    for(int x=0; x<w; x++)
        bulles[y*w+x] = rand()%nbcoul;
}

// Q4
bool Piscine::insere_ligne() {
    parite=1-parite;
    // Verification qu'il y a de la place
    for(int x=0; x<w; x++)
        if(bulles[(h-1)*w+x] != nbcoul)
            return false;
    // Decalage
    for(int y=h-1; y>0; y--)
        for(int x=0; x<w; x++)
            bulles[y*w+x] = bulles[(y-1)*w+x];
    // Insertion
    nouvelle_ligne(0);
    return true;
}

// Q5 Position en pixels du centre de la case logique (x,y)
void Piscine::pos_case(int& x, int& y) const {
    assert(0<=x && x<w && 0<=y && y<h);
    x = marge+rayon*2*x+rayon+((y+parite)%2)*rayon;
    y = marge+y*dy+rayon;
}

// Q12 Inverse de pos_case: retrouve la case la plus proche de la bulle
void Piscine::trouve_case_bulle(int& x, int& y) const {
    y = (b.y-marge-rayon+dy/2)/dy;
    x = (b.x-marge-rayon-((y+parite)%2)*rayon+rayon)/(rayon*2);
}

// Q6
void Piscine::dessine_bulle(int x, int y) const {
    int px=x, py=y;
    pos_case(px,py);
    fillCircle(px, py, rayon-1, coul[bulles[y*w+x]]);
}

// Q6
void Piscine::dessine() const {
    for(int y=0; y<h; y++)
        for(int x=0; x<w; x++)
            dessine_bulle(x,y);
}

// Q8
void Bulle::dessine() const {
    fillCircle((int)x, (int)y, rayon-1, coul[c]);
}
void Bulle::efface() const {
    fillCircle((int)x, (int)y, rayon-1, WHITE);
}

// Q9
void Piscine::init_bulle() {
    b.c = prochaineCoul; // Q22
    b.x = marge+(w/2)*rayon*2+rayon;
    b.y = marge+(h-1)*dy+rayon*2+rayon;
    b.dessine();

    // Q22
    prochaineCoul = rand()%nbcoul;
    fillCircle(marge+rayon/2, marge+(h-1)*dy+2*rayon+margeScore/2, rayon/2,
               coul[prochaineCoul]);

    int x=b.x,y=b.y;
    do {
        getMouse(x,y);
        b.dx = x-b.x;
        b.dy = y-b.y;
        int norme=sqrt(b.dx*b.dx+b.dy*b.dy);
        b.dx /= norme/2;
        b.dy /= norme/2;
    } while(y+rayon>=b.y);
}

// Q14
bool Piscine::voisin(int& x, int& y, int i) const {
    assert(0<=i && i<6);
    const int delta[2][6][2] = {{{-1,0},{1,0},{0,-1},{1,-1},{0,1},{1,1}},
                                {{-1,0},{1,0},{-1,-1},{0,-1},{-1,1},{0,1}}};
    int j = 1-(y+parite)%2;
    x += delta[j][i][0];
    y += delta[j][i][1];
    return (0<=x && x<w && 0<=y && y<h);
}

// Q16
void Piscine::init_vu() {
    for(int i=0; i<w*h; i++)
        vu[i]=false;
}

// Q17
int Piscine::voisins_non_vus(int x, int y) {
    vu[y*w+x]=true;
    int nb=0;
    for(int i=0; i<6; i++) {
        int vx=x, vy=y;
        if(voisin(vx,vy,i) && !vu[vy*w+vx] && bulles[vy*w+vx]==b.c) {
            ++nb;
            nb += voisins_non_vus(vx,vy);
        }
    }
    return nb;
}

// Q18
void Piscine::anime_destruction(int x, int y) {
    bulles[y*w+x]=nbcoul+1;
    dessine_bulle(x,y);
    milliSleep(100);
    bulles[y*w+x]=nbcoul;
    dessine_bulle(x,y);
    ++score; // Q21
}

// Q18
void Piscine::detruis(int x, int y) {
    vu[y*w+x]=true;
    anime_destruction(x,y);
    for(int i=0; i<6; i++) {
        int vx=x, vy=y;
        if(voisin(vx,vy,i) && !vu[vy*w+vx] && bulles[vy*w+vx]==b.c)
            detruis(vx,vy);
    }
}

// Q19
void Piscine::explore(int x, int y) {
    vu[y*w+x] = true;
    for(int i=0; i<6; i++) {
        int vx=x, vy=y;
        if(voisin(vx,vy,i) && !vu[vy*w+vx] && bulles[vy*w+vx]<nbcoul)
            explore(vx,vy);
    }
}

// Q19
void Piscine::detruis_residus() {
    for(int x=0; x<w; x++)
        if(!vu[x] && bulles[x]<nbcoul)
            explore(x,0);
    for(int y=0; y<h; y++)
        for(int x=0; x<w; x++)
            if(!vu[y*w+x] && bulles[y*w+x]<nbcoul)
                anime_destruction(x,y);
}

// Q20
void Piscine::collision(int x, int y) {
    dessine_bulle(x,y);
    init_vu();
    int cc=1+voisins_non_vus(x,y);
    if(cc>=3) {
        init_vu();
        detruis(x,y);
        detruis_residus();
        // Q21 Mise a jour score
        fillRect(marge+w*rayon*2-rayon,
                 marge+(h-1)*dy+2*rayon+margeScore/2-tailleTexte,
                 100,100,WHITE);
        drawString(marge+w*rayon*2-rayon,
                   marge+(h-1)*dy+2*rayon+margeScore/2,
                   to_string(score), BLACK, tailleTexte);
    }
}

// Q10
bool Piscine::bouge_bulle() {
    b.efface();
    int x0,y0;
    trouve_case_bulle(x0,y0);
    if(b.y+b.dy-rayon<marge) { // Q13
        bulles[y0*w+x0]=b.c;
        dessine_bulle(x0,y0);
        return false;
    }
    // Rebond
    if(b.x+b.dx-rayon<marge || b.x+b.dx+rayon>=marge+w*rayon*2+rayon)
        b.dx = -b.dx;
    b.x+=b.dx; b.y+= b.dy;

    // Test collision
    int x,y;
    trouve_case_bulle(x,y);
    for(int i=0; i<6; i++) { // Q15
        int vx=x, vy=y;
        if(voisin(vx,vy,i) && bulles[vy*w+vx]<nbcoul) {
            pos_case(vx,vy);
            int deltax = b.x - vx;
            int deltay = b.y - vy;
            if(deltax*deltax+deltay*deltay > 4*rayon*rayon)
                continue;
            if(! (0<=x0 && x0<w && 0<=y0 && y0<h))
                return false; // Collision avant d'arriver dans une case
            bulles[y0*w+x0]=b.c;
            collision(x0,y0);
            return false;
        }
    }

    b.dessine();
    return true;
}
